#ifdef INC_FLLOP
 #include "fllopaif.h"
#endif

#include "fllopsif.h"



fllopsif::fllopsif()
{
}



fllopsif::~fllopsif()
{
}



/**
  @param n - number of unknowns on the domain
 */
int fllopsif::solver_fllop (long n, long *ci, long *adr, double *a, double *rhs, double *lhs)
{
 #ifdef INC_FLLOP
  //  je-li matice v symmetric compressed rows
  //  je treba poskytnout horni trojuhelnik, ne nase symcomprow
  //  TRY(FllopAIFSetFETIOperator (symcompr->n,symcompr->adr,symcompr->ci,symcompr->a, QP_SYM_UPPER_TRIANGULAR) );
  //  je-li v compresser rows
  //  TRY(FllopAIFSetFETIOperator(n, adr, ci, a, QP_SYM_UNDEF));
  
  // jen pro ucely prvotniho prekladu, jinak pouzit jedno z vyse zakomentovanych volani
  //TRY(FllopAIFSetFETIOperator(n, adr, ci, a));

  //  d - defekt pro jednu podoblast
  long d=1;
  double *ker;
  ker = new double [n*d];
  //  my musime naplnit pole ker po sloupcich 
  FllopAIFSetFETIOperatorNullspaceDense(n, d, ker);
  //  rhs - nase prava strana na jedne domene
  FllopAIFSetRhs(n, rhs);
	
  //  m dualni dimenze - pocet vsech multiplikatoru v uloze
  //  je treba sestavit matici vazeb B do compressed rows
  //  matice B ma tolik radku, kolik je multiplikatoru v cele uloze a tpolik
  //  sloupcu, kolik je posunu na konkretni domene
  //  pokud chceme TFETI, nedefinujeme Dirichletovy podminky, pridame prvky do matice B

  //  comprow bmat;

  //  vektor prave strany rovbnostnich vazeb - skoky nebo slip mezi domenami
  //  v pripade klasicke dekompozice, sl je nulovy vektor
  // double *sl;
  // long m = n;

  //  TRY( FllopAIFSetEq(m, n, PETSC_FALSE, PETSC_TRUE, bmat.adr, bmat.ci, bmat.a, sl));

  // TRY( FllopAIFFetiPrepare(PETSC_TRUE,PETSC_TRUE,PETSC_DECIDE) );
  // jen pro ucely prvotniho prekladu, jinak pouzit jedno z vyse zakomentovanych volani
  FllopAIFFetiPrepare(PETSC_TRUE);

  //  lhs je vektor reseni
  FllopAIFSetSolutionVector(n, lhs);
  FllopAIFSolve();
  // TRY( FllopAIFReset() );
 #endif

  return 0;
}
